com.genesyslab.wfm8.API.service.adherence850

## Interface WFMAdherenceService850Soap

-     public interface WFMAdherenceService850Soap

  At any given moment every agent is at some state assigned by Genesys Framework. There is predefined set of available Agent States. Also agent state may have user-defined "reason" code(s) attached to fine grain it further. The Agent State of every agent is tracked in real-time and is logged to database by WFM Data Aggregator. The agent state log fully illustrates agent's activity. The database format is made proprietary for performance reasons although historical Agent State information is made readily available by Adherence Service. The historical Agent State information can be compared against published agent schedule to monitor agent's adherence to schedule. The rules of Agent State adherence or non-adherence to specific scheduled agent states are completely user-configurable and can be accessed from Configuration Service. A timeframe when agent state is non-adherent (or adherent) to published schedule state is named Adherence Event. The Adherence Service provides interface for accessing dynamically generated Adherence Event records for the given time period. Most often agent adherence events are presented grouped by calendar days in reports. To make it more convenient Adherence Service also provides Agent Adherence Events grouped by day as a separate record. The rules of Agent State adherence or non-adherence to specific Scheduled Agent States are completely user-configurable and can be accessed from Config Service. The configuration State Group Object contains information that defines which Agent States are adherent to which Schedule States as well as adherence thresholds. Another configuration object State Object defines binding between Schedule State and State Group.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAgentStateAsync(int siteID, double startDateTime, double endDateTime, java.util.List<java.lang.Integer> teamIDArray, java.util.List<java.lang.Integer> agentIDArray, java.lang.String auxCodeFilter, java.util.List<java.lang.Integer> agentStateIDFilter)` Used to retrieve historical Agent States for the specified time period.
    `AdhAgentStateHolder` | `getAgentStateResults(java.lang.String requestID)` Returns results of asynchronous getAgentStateAsync request once completed.
    `java.lang.String` | `getDayEventAsync(int siteID, double startDate, double endDate, java.util.List<java.lang.Integer> teamIDArray, java.util.List<java.lang.Integer> agentIDArray, boolean includeCompliantEvents, boolean includeAllUniqueEvents, boolean excludeDaysWithoutShift, boolean provideScheduleStateInfo)` Used to retrieve adherence events for the specified date period.
    `AdhDayEventHolder` | `getDayEventResults(java.lang.String requestID)` Returns results of asynchronous getDayEventAsync request once completed.
    `java.lang.String` | `getEventAsync(int siteID, double startDateTime, double endDateTime, java.util.List<java.lang.Integer> teamIDArray, java.util.List<java.lang.Integer> agentIDArray, boolean includeCompliantEvents, boolean includeAllUniqueEvents, boolean excludeDaysWithoutShift, boolean provideScheduleStateInfo)` Used to retrieve adherence events for the specified time period.
    `AdhEventHolder` | `getEventResults(java.lang.String requestID)` Returns results of asynchronous getEventAsync request once completed.
    `java.lang.String` | `getTeamTotalsAsync(int siteID, double startDate, double endDate, java.util.List<java.lang.Integer> teamIDArray, int granularity, boolean excludeDaysWithoutShift)` Used to retrieve various team adherence totals for the specified date period and granularity.
    `java.lang.String` | `getTotalsAsync(int siteID, double startDate, double endDate, java.util.List<java.lang.Integer> teamIDArray, java.util.List<java.lang.Integer> agentIDArray, int granularity, boolean excludeDaysWithoutShift)` Used to retrieve various adherence totals for the specified date period and granularity.
    `AdhTotalsHolder` | `getTotalsResults(java.lang.String requestID)` Returns results of asynchronous getTotalsAsync request once completed.

- - ### Method Detail

    - #### getAgentStateAsync

          java.lang.String getAgentStateAsync(int siteID,
                                            double startDateTime,
                                            double endDateTime,
                                            java.util.List<java.lang.Integer> teamIDArray,
                                            java.util.List<java.lang.Integer> agentIDArray,
                                            java.lang.String auxCodeFilter,
                                            java.util.List<java.lang.Integer> agentStateIDFilter)

      Used to retrieve historical Agent States for the specified time period. The function is asynchronous and so it returns request ID, which subsequently shall be used to check the progress/status of request with corresponding Session Service functions. When request is complete, GetAgentStateResults function shall be called to retrieve the results.
      Parameters:
        `siteID` - Site ID, identifies `CfgSite` object
        `startDateTime` - Period start date/time `OleDateTime`
        `endDateTime` - Period end date/time `OleDateTime`
        `teamIDArray` - Team ID filter. Use "null" value to ignore Team filter
        `agentIDArray` - Agent ID filter. Use "null" value to ignore Agent filter
        `auxCodeFilter` - Defines reason code filter. An empty string means no filter.
        `agentStateIDFilter` - An array of Genesys Agent State IDs to filter results by. A "null" value means no filter.
      Returns:
        An asynchronous request ID

    - #### getAgentStateResults

          AdhAgentStateHolder getAgentStateResults(java.lang.String requestID)

      Returns results of asynchronous getAgentStateAsync request once completed.
      Parameters:
        `requestID` - An asynchronous request ID
      Returns:
        `AdhAgentStateHolder`

    - #### getEventAsync

          java.lang.String getEventAsync(int siteID,
                                       double startDateTime,
                                       double endDateTime,
                                       java.util.List<java.lang.Integer> teamIDArray,
                                       java.util.List<java.lang.Integer> agentIDArray,
                                       boolean includeCompliantEvents,
                                       boolean includeAllUniqueEvents,
                                       boolean excludeDaysWithoutShift,
                                       boolean provideScheduleStateInfo)

      Used to retrieve adherence events for the specified time period. The function is asynchronous and so it returns request ID, which subsequently shall be used to check the progress/status of request with corresponding Session Service functions. When request is complete, GetEventResults function shall be called to retrieve the results.
      Parameters:
        `siteID` - Site ID, identifies `CfgSite` object
        `startDateTime` - Period start date/time `OleDateTime`
        `endDateTime` - Period end date/time `OleDateTime`
        `teamIDArray` - Team ID filter. Use "null" value to ignore Team filter
        `agentIDArray` - Agent ID filter. Use "null" value to ignore Agent filter
        `includeCompliantEvents` - Tells whether compliant and non-compliant events shall be returned or only non-compliant.
        `includeAllUniqueEvents` - Indicates how adherence events should be generated based on available agent states and the schedule. If checked, all unique combinations of different agent states and scheduled states create new events. If unchecked only agent states with different status generate new event if scheduled state is the same. Different scheduled states always generate new events.
        `excludeDaysWithoutShift` - Tells to exclude (or not) schedule days, which have no shift scheduled
        `provideScheduleStateInfo` - Indicates whether schedule state descriptive information should be returned with results or not.
      Returns:
        An asynchronous request ID

    - #### getEventResults

          AdhEventHolder getEventResults(java.lang.String requestID)

      Returns results of asynchronous getEventAsync request once completed.
      Parameters:
        `requestID` - An asynchronous request ID
      Returns:
        `AdhEventHolder`

    - #### getDayEventAsync

          java.lang.String getDayEventAsync(int siteID,
                                          double startDate,
                                          double endDate,
                                          java.util.List<java.lang.Integer> teamIDArray,
                                          java.util.List<java.lang.Integer> agentIDArray,
                                          boolean includeCompliantEvents,
                                          boolean includeAllUniqueEvents,
                                          boolean excludeDaysWithoutShift,
                                          boolean provideScheduleStateInfo)

      Used to retrieve adherence events for the specified date period. The function is asynchronous and so it returns request ID, which subsequently shall be used to check the progress/status of request with corresponding Session Service functions. When request is complete, GetDayEventResults function shall be called to retrieve the results.
      Parameters:
        `siteID` - Site ID, identifies `CfgSite` object
        `startDate` - Period start date `OleDateTime`
        `endDate` - Period end date `OleDateTime`
        `teamIDArray` - Team ID filter. Use "null" value to ignore Team filter
        `agentIDArray` - Agent ID filter. Use "null" value to ignore Agent filter
        `includeCompliantEvents` - Tells whether compliant and non-compliant events shall be returned or only non-compliant.
        `includeAllUniqueEvents` - Indicates how adherence events should be generated based on available agent states and the schedule. If checked, all unique combinations of different agent states and scheduled states create new events. If unchecked only agent states with different status generate new event if scheduled state is the same. Different scheduled states always generate new events.
        `excludeDaysWithoutShift` - Tells to exclude (or not) schedule days, which have no shift scheduled
        `provideScheduleStateInfo` - Indicates whether schedule state descriptive information should be returned with results or not.
      Returns:
        An asynchronous request ID

    - #### getDayEventResults

          AdhDayEventHolder getDayEventResults(java.lang.String requestID)

      Returns results of asynchronous getDayEventAsync request once completed.
      Parameters:
        `requestID` - An asynchronous request ID
      Returns:
        `AdhDayEventHolder`

    - #### getTotalsAsync

          java.lang.String getTotalsAsync(int siteID,
                                        double startDate,
                                        double endDate,
                                        java.util.List<java.lang.Integer> teamIDArray,
                                        java.util.List<java.lang.Integer> agentIDArray,
                                        int granularity,
                                        boolean excludeDaysWithoutShift)

      Used to retrieve various adherence totals for the specified date period and granularity. The function is asynchronous and so it returns request ID, which subsequently shall be used to check the progress/status of request with corresponding Session Service functions. When request is complete, GetTotalsResults function shall be called to retrieve the results.
      Parameters:
        `siteID` - Site ID, identifies `CfgSite` object
        `startDate` - Period start date `OleDateTime`
        `endDate` - Period end date `OleDateTime`
        `teamIDArray` - Team ID filter. Use "null" value to ignore Team filter
        `agentIDArray` - Agent ID filter. Use "null" value to ignore Agent filter
        `granularity` - Granularity for which totals shall be calculated within the period `EAdhGranularity`
        `excludeDaysWithoutShift` - Tells to exclude (or not) schedule days, which have no shift scheduled
      Returns:
        An asynchronous request ID

    - #### getTotalsResults

          AdhTotalsHolder getTotalsResults(java.lang.String requestID)

      Returns results of asynchronous getTotalsAsync request once completed.
      Parameters:
        `requestID` -
      Returns:
        `AdhTotalsHolder`

    - #### getTeamTotalsAsync

          java.lang.String getTeamTotalsAsync(int siteID,
                                            double startDate,
                                            double endDate,
                                            java.util.List<java.lang.Integer> teamIDArray,
                                            int granularity,
                                            boolean excludeDaysWithoutShift)

      Used to retrieve various team adherence totals for the specified date period and granularity. The function is asynchronous and so it returns request ID, which subsequently shall be used to check the progress/status of request with corresponding Session Service functions. When request is complete, GetTotalsResults function shall be called to retrieve the results.
      Parameters:
        `siteID` - Site ID, identifies `CfgSite` object
        `startDate` - Period start date `OleDateTime`
        `endDate` - Period end date `OleDateTime`
        `teamIDArray` - Team ID filter. Use "null" value to ignore Team filter
        `granularity` - Granularity for which totals shall be calculated within the period `EAdhGranularity`
        `excludeDaysWithoutShift` - Tells to exclude (or not) schedule days, which have no shift scheduled
      Returns:
        An asynchronous request ID

Copyright © 2005-2016 Genesys Telecommunications Labs, Inc. All Rights Reserved.